rm(list = ls(all = TRUE))
set.seed(24850)
source("../analysis/functions/helpers-forecasting.R")
source("../analysis/functions/helpers-general.R")
print(load("../res/FCSTERR.rda"))

## Univariate Forecasting (Harvey & Newbold, 2000)
H <- FCSTERR$hor01
## pvals <- sapply(1:ncol(H), function(i) diebold.mariano.mult(H[,i], H[,-i])$p.value)
## names(pvals) <- colnames(H)
## pvals
## modified Diebold-Mariano (1995)
A <- sapply(2:ncol(H), function(i)
            diebold.mariano.test(abs(H[,1]) - abs(H[,i]), hypothesis = "less", k = 0, h = 1)$p.value)
names(A) <- colnames(H)[-1]

H <- FCSTERR$hor06
B <- sapply(2:ncol(H), function(i)
            diebold.mariano.test(abs(H[,1]) - abs(H[,i]), hypothesis = "less", k = 5, h = 6)$p.value)
names(B) <- colnames(H)[-1]

H <- FCSTERR$hor12
C <- sapply(2:ncol(H), function(i)
            diebold.mariano.test(abs(H[,1]) - abs(H[,i]), hypothesis = "less", k = 11, h = 12)$p.value)
names(C) <- colnames(H)[-1]







## Exogenous Forecasting
idx <- c("ifo", "zew", "oecd", "com", "faz", "rovnght", "rspread", "emp", "factor") 
print(load("../res/FCSTEXOG.rda"))
extractindex <- function(obj = FCSTEXOG, ind = "ifo", ch = 1){
  RES <- FCSTEXOG[["AR"]][,ch]
  for(i in 2:length(FCSTEXOG)){
    RES <- cbind(RES, FCSTEXOG[[i]][[ind]][,ch])
  }
  colnames(RES) <- names(FCSTEXOG)
  RES
}

                
ii <- 1
RRES <- list()
for(h in c(1,6,12)){ # h <- 1 
  RES <- NULL
  for(z in idx){
    H <- extractindex(FCSTEXOG, z, ii)   # apply(a^2,2,mean) * 1000 # to recreate Table 7
    a <- sapply(2:ncol(H), function(j)
                diebold.mariano.test(abs(H[,1]) - abs(H[,j]), hypothesis = "less", k = h-1, h = h)$p.value)
    names(a) <- colnames(H)[-1]
    RES <- rbind(RES,a)
  }
  rownames(RES) <- idx
  RRES[[ii]] <- RES
  ii <- ii + 1
}

boldify(round(RRES[[1]][,c(4,3,1,2,5,6)],3), cnames = TRUE)
boldify(round(RRES[[2]][,c(4,3,1,2,5,6)],3), cnames = FALSE)
boldify(round(RRES[[3]][,c(4,3,1,2,5,6)],3), cnames = FALSE)
                
