################################################################################
## Fill the repository
################################################################################
rm(list = ls())
set.seed(123)
source("../analysis/functions/simts.R")             # define ts-functions
## FIXME: new dirs !
if(!"datawork" %in% dir()) dir.create("../datawork")
if(!"repository" %in% dir("datawork")) dir.create("../datawork/repository")

myfe <- 0.1                             
itr <- 100                              # number of sim. time series
lens <- c(60, 110, 210)                 # lengths of the ts + lag
fnc <- c("NLAR1a", "NLAR1b", "NLAR2a", "NLAR2b", "NLAR2c", "NLAR2d",
         "NLAR2e", "NLAR4")

for(j in lens){
  for (z in fnc){ # j = 60; z = "NLAR1a"
    f <- get(z, mode = "function", envir = parent.frame())
    formals(f)[c("fe")] <- c(myfe)
    simy <- sapply(rep(j,itr), f, simplify = FALSE)
    
    ## store the ts
    fileName <- paste(z,".", j ,".RData", sep = "") 
    pathName <- paste("../datawork/repository/",fileName,sep="")
    save(simy, file = pathName)
  }
}
